﻿using AirBomber.Entities;
using AirBomber.Rendering;

namespace AirBomber.Generics
{
    internal class BomberCompareByColor : IComparer<BomberRendererBase?>
    {
        public int Compare(BomberRendererBase? lhs, BomberRendererBase? rhs)
        {
            if (lhs == null || lhs.EntityBomber == null)
                throw new ArgumentNullException(nameof(lhs));

            if (rhs == null || rhs.EntityBomber == null)
                throw new ArgumentNullException(nameof(rhs));

            var BaseColorCompare = lhs.EntityBomber.BodyColor.Name.CompareTo(rhs.EntityBomber.BodyColor.Name);

            if ( !(lhs is BomberRenderer && rhs is BomberRenderer) )
                return BaseColorCompare;

            // Если оба объекта - продвинутого типа, сравниваем еще и по дополнительному цвету
            return 
                ((BomberEntity)lhs.EntityBomber).AdditionalColor.Name.CompareTo(((BomberEntity)rhs.EntityBomber).AdditionalColor.Name);
        }
    }
}
