﻿using AirBomber.Rendering;

namespace AirBomber.Generics
{
    internal class BomberCompareByType : IComparer<BomberRendererBase?>
    {
        public int Compare(BomberRendererBase? lhs, BomberRendererBase? rhs)
        {
            if (lhs == null || lhs.EntityBomber == null)
                throw new ArgumentNullException(nameof(lhs));

            if (rhs == null || rhs.EntityBomber == null)
                throw new ArgumentNullException(nameof(rhs));

            if (lhs.GetType().Name != rhs.GetType().Name)
                return lhs.GetType().Name.CompareTo(rhs.GetType().Name);

            var SpeedCompare = lhs.EntityBomber.Speed.CompareTo(rhs.EntityBomber.Speed);
            if (SpeedCompare != 0)
                return SpeedCompare;

            return lhs.EntityBomber.Weight.CompareTo(rhs.EntityBomber.Weight);
        }
    }
}
